%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%This is a example for the optimization of Elementary Mode Coefficients %
%%(EMCs) by Maximum Entropy Principle                                    % 
%%It is for a model network                                              %
%%emmatrix is a matrix of EMs: Reaction*EMs (M*N)                        %
%%fluxv is a flux vector for the determined fluxes(N*1)                  %
%%Objective function is to maximize the Shannon entropy                  %
%%                                                                       %
%%Corresponding author: Prof. Hiroyuki Kurata                            %
%%kurata@bio.kyutech.ac.jp                                               %
%%Kyushu Institute of Technology, Iizuka, Fukuoka, Japan                 %
%%2007.10                                                                %  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function example
clear all
global uptakeflux uptake
disp('Please input the name of data file for the optimization')
disp('Make sure the date format is right')
alldata=input('The file name is;   ','s')
datas=textread(alldata);

nr=datas(1,1);% the number of reactions
nd=datas(1,2);% the number of determined fluxes for optimization
uptakeflux=datas(1,3);% the flux for uptake reaction

%input the matrix A
for i=2:1:(nd+1)
emmatrix(i-1,:)=datas(i,:);
end
[a1,a2]=size(emmatrix);
%input the mxtrix b
for i=1:1:nd
fluxv(1,i)=datas(nd+2,i);
end

%input the vector for uptake reaction in elmentary mode matrix
uptake=datas(nd+3,:);

%input elementary mode matrix
for i=(nd+4):1:(nd+3+nr)
emall(i-nd-3,:)=datas(i,:);
end

x0=uptakeflux/a2*ones(a2,1);
lb=1e-9*ones(a2,1);
hb=100*ones(1,a2);
options=optimset('LargeScale','off');
[x,fval]=fmincon(@func,x0,[],[],emmatrix,fluxv,lb,hb,[],options)
fluxdistribution=emall*x;
disp('Flux distribution is: ')
disp(fluxdistribution)
save('outputEMC.dat','x','-ascii');
save('outputflux.dat','fluxdistribution','-ascii');
disp('Optimization is successful. You can close it now.')
pause

function f=func(y)
global uptakeflux uptake
f=0;
[u1,u2]=size(uptake);
for i=1:u2
    if uptake(1,i)~=0.0
    f=f+uptake(1,i)*y(i)/uptakeflux*log(uptake(1,i)/uptakeflux*y(i));
    end
    disp(f)
end